//+------------------------------------------------------------------+
//|                                               TimeAndSales.mq4   |
//|                   Copyright 2008-2015, Clusterdelta.com          |
//|                                          http://clusterdelta.com |
//+------------------------------------------------------------------+
#property copyright   "Clusterdelta.com"
#property link        "http://my.clusterdelta.com/ts"
#property description "Time And Sales for Metatrader"

#import "ts_clusterdelta.dll"
int    TS_Start(int &, string, string);
string Get_TS_Buffer(int &);
#import


#define MAGICCLUSTERDELTA 20150923

input string TS_SETTINGS="==== T&S Parameters ====";
input bool Show_TS=true;
input color ASK_Color=YellowGreen;
input color BID_Color=OrangeRed;
input int MinVolume=0;
input int Forex_Shift=0;
input string Instrument="AUTO";
input color Title_Color=Gray;
input color Time_ASK_Color=Gray;
input color Time_BID_Color=Gray;
input string Rows = "AUTO";
input color Background=Black;
input color Border=Gray;
input int Hour_Shift=0;
input string DOM_SETTINGS="==== DOM Parameters ====";
input int Width_In_Pixels=150; 
input bool Display_DOM=true;
input bool Show_PRICE=true;
input bool Show_VOLUME=true;
input bool Use_Forex_Shift=true;
input color PriceColor=LightGray;
input color VolumeColor=LightGray;

int ActualWidth=150;


int X_coord=50;
int Y_coord=40;

static bool AlreadyInit=false;
static bool DeInit=false;
int Lines=25;

void OnInit()
{
  ActualWidth=Width_In_Pixels;
  if (Width_In_Pixels<40) { ActualWidth=40; }
  if (Width_In_Pixels>400) { ActualWidth=400; }
  DeInit=false;
  AlreadyInit=false;
  EventSetMillisecondTimer(100);
}

void OnTick()
{

  if(!AlreadyInit) 
  { 
    AlreadyInit=true;
    init_ts();    
  }
  if(DeInit) return;
  
  Check_for_TS_Updates();
  Sleep(100);

}

void OnTimer()
{
  OnTick();
}


  
void init_ts()
{
  int k=0,i;
  i=TS_Start(k, Instrument, Symbol());   
  if (i < 0) { Alert ("Error during startup Time&Sales"); return; }
  InitLines();
}  


void OnDeinit(const int reason)
{
  EventKillTimer();
  DeInit = true;
  ObjectDelete("TimeAndSales_Title");
  ObjectDelete("TimeAndSales_Site");  
  ObjectDelete("TS_Rectangle");
  int    obj_total=ObjectsTotal();
  for(int i=0;i<obj_total;i++)
    {
     while ((StringSubstr(ObjectName(i),0,7) == "TS_Line")) { ObjectDelete(ObjectName(i));  }
    }
  for(i=0;i<obj_total;i++)
    {
     while ((StringSubstr(ObjectName(i),0,3) == "DOM")) { ObjectDelete(ObjectName(i));  }
    }
    
  return;
}

void Check_for_TS_Updates()
{
   
   int s,i,d;
   color TimeColor,AskBidColor;
   int current_width,  n, max_vol;
   string Pr, vol;
   string IncomingTime[500],IncomingPrice[500],IncomingVolume[500],IncomingType[500],DOM_index[200],DOM_price[200],DOM_volume[200];
   static string DOM_vols[200];
   static int max_index=0;
   max_vol=1;
   s = Get_Updates_From_DLL(IncomingTime,IncomingPrice,IncomingType,IncomingVolume,DOM_index,DOM_price,DOM_volume,d);
   if (s>Lines) s=Lines;
   if(i>100) i=100;
   if(d>0){
   for(i=0; i<d; i++)
   {
     n = StringToInteger(DOM_index[i])*2;
     if(n<0) n=MathAbs(n)-1;
     DOM_vols[n]=DOM_volume[i];
     if(i>max_index){max_index=i;}
   }
   for (i=0; i<max_index; i++)
   {
     if(max_vol<StringToInteger(DOM_vols[i])){max_vol=StringToInteger(DOM_vols[i]);}
   }
   
   
   
   //DOM
   for (i=0; i<d; i++) //
   {
     n = StringToInteger(DOM_index[i]);
     Pr = DOM_price[i];
     vol = DOM_volume[i];
     if(!(max_vol>0))
     {
       max_vol=1;
     }
       current_width = MathRound(StringToInteger(vol) * ActualWidth / max_vol); 
     
     if(StringToDouble(Pr)>0)
     {
       if (Display_DOM) { Create_DOM(n, DoubleToString(NormalizeDouble(Pr,Digits()),Digits()), vol, current_width); }
     }
   
   }   
   }//if d>0

   if(s>0 && Show_TS) 
   { 
     ShiftLines(s);

     // T&S
     for (i=0; i<s; i++)
     {
       if(IncomingType[i]=="B") { AskBidColor=BID_Color; TimeColor = Time_BID_Color; } else   { AskBidColor=ASK_Color; TimeColor = Time_ASK_Color; }
       SetLineN_Text(i+1,IncomingTime[i],IncomingPrice[i],IncomingVolume[i],AskBidColor,TimeColor);
     
     }
   }

   ChartRedraw(ChartID());

}

int Get_Updates_From_DLL(string& OutTime[], string& OutPrice[], string& OutType[], string& OutVolume[], string& OutDOM[],string& DOMp[],string& DOMv[], int &d)
{
   int i;
   string ts_stream;
   string packet[800];
   int sent_rows=0;
   ts_stream = Get_TS_Buffer(sent_rows);
   Parse_String(ts_stream,";",packet);

   //Check Header
   int line=0;
   int correct=0;
   int dom_lines=0;

   for(i=0; i<sent_rows; i++)
   {
    if(packet[i*8+correct]!="CDTS" && packet[i*8+correct]!="CDDM") // unknown header
    {
      correct++;
      if(correct==8)
      {
        sent_rows--;
        correct=0;
      }
    }
    if(packet[i*8+correct]=="CDTS")
    {
      if (StrToInteger(packet[i*8+7+correct])>=MinVolume)
      {
        OutTime[line]= IntegerToString(StringToInteger(StringSubstr(packet[i*8+correct+4],11,2))+Hour_Shift)+StringSubstr(packet[i*8+correct+4],13); 
        OutPrice[line]=packet[i*8+correct+5];
        OutType[line]=packet[i*8+correct+6];     
        OutVolume[line]=packet[i*8+correct+7];          
        line++;
      }
    }
    if(packet[i*8+correct]=="CDDM")
    {
      if (packet[i*8+correct+6] == "A")
      {
        OutDOM[dom_lines]= IntegerToString(StringToInteger(StringSubstr(packet[i*8+correct+3],2)));
      }
      if (packet[i*8+correct+6] == "B")
      {
        OutDOM[dom_lines]= IntegerToString(-1*StringToInteger(StringSubstr(packet[i*8+correct+3],2)));
      }
      DOMp[dom_lines] = packet[i*8+correct+5];
      DOMv[dom_lines] = packet[i*8+correct+7];
      dom_lines++;

    }
   }
   d=dom_lines;
   return (line);
}

void Parse_String(string str, string pattern, string& parsed[])
{
  int pos=0,i;
  int n=0;
  string key;

  i=StringFind(str, pattern, pos);
  while(i!=-1 && n<700)
  {
    key = "";
    if(i-pos >0 ) { 
      key = StringSubstr(str,pos,i-pos);
    }
    parsed[n]= key;
    n++;
    pos = i+StringLen(pattern);
    i=StringFind(str, pattern, pos);
  }
  parsed[n]=StringSubstr(str,pos);

}

void ShiftLines(int NumberOfLines)
{

  if(NumberOfLines>=Lines) return;

  int s,n;
  string VolumeGetName, VolumeSetName, VolumePriceGetName,VolumePriceSetName, VolumeTimeGetName, VolumeTimeSetName;
  string VolumeValue, VolumePriceValue, VolumeTimeValue;
  color oldTextColor, oldTimeColor;
  //Comment(Lines-NumberOfLines);  
  n=Lines;
  s=Lines-NumberOfLines;
  
  while (s>=1)
  {
    
    VolumeGetName =  "TS_Line_Volume_"+s;
    VolumeSetName =  "TS_Line_Volume_"+n;
    
    VolumePriceGetName =  "TS_Line_Price_"+s;
    VolumePriceSetName =  "TS_Line_Price_"+n;

    VolumeTimeGetName =  "TS_Line_Time_"+s;
    VolumeTimeSetName =  "TS_Line_Time_"+n;


    VolumeTimeValue = ObjectGetString(0,VolumeTimeGetName,OBJPROP_TEXT);    
    VolumePriceValue = ObjectGetString(0,VolumePriceGetName,OBJPROP_TEXT);
    VolumeValue = ObjectGetString(0,VolumeGetName,OBJPROP_TEXT);    
    oldTextColor = ObjectGet(VolumeGetName,OBJPROP_COLOR);
    oldTimeColor = ObjectGet(VolumeTimeGetName,OBJPROP_COLOR);    

    ObjectSetText(VolumeSetName,VolumeValue,8,"Arial",oldTextColor);
    ObjectSetText(VolumePriceSetName,VolumePriceValue,8,"Arial",oldTextColor);
    ObjectSetText(VolumeTimeSetName,VolumeTimeValue,8,"Arial",oldTimeColor);
    n--; s--;
  }
 
   
    

}

void InitLines()
{

  if(!Show_TS) return;
  int j;

  string Time_Text="";
  string Price_Text="";  
  string Volume_Text="";  
    
  color Line_Color=ASK_Color;
  color Time_Color=Time_ASK_Color;
  
  string TS_Name="TimeAndSales_Title";
  string TS_Text="Time And Sales v2.0     ";
  
  string TS_SiteName="TimeAndSales_Site";
  string TS_SiteText="http://my.clusterdelta.com/ts";
  

//---   
  long x_distance;
  long y_distance;
//---   
   if(!ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0,x_distance))
     {
      DeInit=true;
      return;
     }
   if(!ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0,y_distance))
     {
      DeInit=true;
      return;
     }
   if (!(StringToInteger(Rows)>0))
   {
     Lines = MathRound((y_distance - 102) / 13);
   } else
   {
     Lines = StringToInteger(Rows);
   }
   if (Lines > 100) Lines=100;
   if (Lines <= 0) Lines=25;   

   int x;
   int y;
   int width;
   int height;

   x = x_distance - 210; y=35;
   width = 170;
   height = 42 + Lines * 13;
   
   RectLabelCreate(0,"TS_Rectangle",0,x,y,width,height,Background,BORDER_FLAT,0,Border,STYLE_SOLID,1,true,false,false,0);
   X_coord=x_distance-202;
   Y_coord=40;


   ObjectCreate(TS_Name, OBJ_LABEL, 0, 0, 0);
   ObjectSet(TS_Name, OBJPROP_CORNER, 0);    
   ObjectSet(TS_Name, OBJPROP_XDISTANCE, X_coord+20);
   ObjectSet(TS_Name, OBJPROP_YDISTANCE, Y_coord-2);
   ObjectSetText(TS_Name,TS_Text,10,"Arial",Title_Color);  

   ObjectCreate(TS_SiteName, OBJ_LABEL, 0, 0, 0);
   ObjectSet(TS_SiteName, OBJPROP_CORNER, 0);    
   ObjectSet(TS_SiteName, OBJPROP_XDISTANCE, X_coord+10);
   ObjectSet(TS_SiteName, OBJPROP_YDISTANCE, Y_coord+14);
   ObjectSetText(TS_SiteName,TS_SiteText,8,"Arial",Title_Color);  

  
   for (j=1; j<=Lines; j++)
   {
    Time_Text = "";
    Price_Text = "";
    Volume_Text = "";
    Line_Color = ASK_Color;
    Time_Color = Time_ASK_Color;
    
    CreateLine(j);
    SetLineN_Coords(j,X_coord,Y_coord+16);
    SetLineN_Text(j,Time_Text,Price_Text,Volume_Text,Line_Color,Time_Color);
   }

}

void CreateLine(int n)
{
  CreateLine_Type(n, "Time");
  CreateLine_Type(n, "Price");
  CreateLine_Type(n, "Volume");
}

void CreateLine_Type(int n, string LineType)
{
    string Line_Name = "TS_Line_"+LineType+"_"+IntegerToString(n);
    ObjectGet(Line_Name,OBJPROP_COLOR);
    int Error=GetLastError();               //      
    if (Error==4202)
    {
       ObjectCreate(Line_Name, OBJ_LABEL, 0, 0, 0);//  . "Label_Obj_MACD" ,      (       ). OBJ_LABEL -   , ,        (    ).      ,       ( ,    ,    0).
    }   
}

void SetLineN_Coords(int n, int x, int y)
{
  SetLineN_Coords_Type(n,x,y,"Time");
  SetLineN_Coords_Type(n,x+70,y,"Price");
  SetLineN_Coords_Type(n,x+135,y,"Volume");
  
}
void SetLineN_Coords_Type(int n, int x, int y, string LineType)
{
    string Line_Name="TS_Line_"+LineType+"_"+IntegerToString(n);
    ObjectSet(Line_Name, OBJPROP_CORNER, 0);    //     
    ObjectSet(Line_Name, OBJPROP_XDISTANCE, x);//     
    ObjectSet(Line_Name, OBJPROP_YDISTANCE, y+n*13);//  Y
}
void SetLineN_Text(int n, string Time_Text,string Price_Text,string Volume_Text,color Line_Color, color Time_Color)
{
   SetLineN_Text_Type (n,Time_Text,Time_Color,"Time");
   SetLineN_Text_Type (n,Price_Text,Line_Color,"Price");   
   SetLineN_Text_Type (n,Volume_Text,Line_Color,"Volume");      
   
}
void SetLineN_Text_Type(int n, string Text, color LineColor, string LineType)
{
    string Line_Name="TS_Line_"+LineType+"_"+IntegerToString(n);
    if (LineType == "Volume") {Text = StringFormat("%4s",Text); }
    if (LineType == "Price" && StrToDouble(Text)>0) {Text = DoubleToString(NormalizeDouble(StrToDouble(Text)+Forex_Shift*Point,Digits()),Digits()); }
    ObjectSetText(Line_Name,Text,8,"Arial",LineColor);
}

bool RectLabelCreate(const long             chart_ID=0,               // ID 
                     const string           name="RectLabel",         //  
                     const int              sub_window=0,             //  
                     const int              x=0,                      //    X
                     const int              y=0,                      //    Y
                     const int              width=50,                 // 
                     const int              height=18,                // 
                     const color            back_clr=C'236,233,216',  //  
                     const ENUM_BORDER_TYPE border=BORDER_SUNKEN,     //  
                     const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    
                     const color            clr=clrRed,               //    (Flat)
                     const ENUM_LINE_STYLE  style=STYLE_SOLID,        //   
                     const int              line_width=1,             //   
                     const bool             back=false,               //   
                     const bool             selection=false,          //   
                     const bool             hidden=true,              //    
                     const long             z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
     {
//      Print(__FUNCTION__,
//            ":     !   = ",GetLastError());
//      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---     (  Flat)
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }

void LabelCreate(const int xcoord, const int ycoord, string TS_Name, string TS_Text, color titleColor)
{

   ObjectCreate(TS_Name, OBJ_LABEL, 0, 0, 0);
   ObjectSet(TS_Name, OBJPROP_CORNER, 0);    
   ObjectSet(TS_Name, OBJPROP_XDISTANCE, xcoord);
   ObjectSet(TS_Name, OBJPROP_YDISTANCE, ycoord);
   ObjectSetText(TS_Name,TS_Text,8,"Arial",titleColor);  
   
}

bool Create_DOM(int n, string Price, string Vol, int mywidth)
{
   long x_distance;
   ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0,x_distance);
   int x,y,PriceX, PriceY;
   
   ChartTimePriceToXY(0,0,Time[0],Close[0],x,y);  
   
   PriceX = x_distance - ActualWidth - 4;
   PriceY = y;


   if(Show_TS) PriceX=PriceX-210;
   int height=15;
   int x_shift=0;
   color Bg=Lavender;
   string Text="";

   
   
   string RectName = "DOM_A"+IntegerToString(n);
   string LabelName = RectName+"_TEXT";
   string LabelVName = RectName+"_VOL";   
   
   if (MathAbs(n)==2) Bg=Linen;
   if (MathAbs(n)==3) Bg=LightYellow;
   if (MathAbs(n)==4) Bg=LemonChiffon;   
   if (MathAbs(n)==5) Bg=Beige;   
   if (MathAbs(n)==6) Bg=WhiteSmoke;
   if (MathAbs(n)==7) Bg=LightYellow;
   if (MathAbs(n)==8) Bg=OldLace;   
   if (MathAbs(n)==9) Bg=Bisque;   
   if (MathAbs(n)==10) Bg=MistyRose;      

/*
input bool Show_PRICE=true;
input bool Show_VOLUME=true;
input bool Use_Forex_Shift=true;
*/

   if(Show_PRICE) x_shift=7*StringLen(Price)+3;
   
   RectLabelCreate(0,RectName,0,PriceX-x_shift + ActualWidth-mywidth ,PriceY-10-height*n+n,mywidth,height,Bg,BORDER_FLAT,0,Black,STYLE_SOLID,1,true,false,false,0);
   if (Show_PRICE)
   {
     if(Use_Forex_Shift)
     {
       Text = DoubleToString(NormalizeDouble(StrToDouble(Price)+Forex_Shift*Point,Digits()),Digits()); 
     } else { Text=Price; }
     
     LabelCreate(PriceX+ActualWidth-7*StringLen(Price), PriceY-10-height*n+n, LabelName, Text, PriceColor);
   }
   if (Show_VOLUME)
   {
     LabelCreate(PriceX-x_shift+ActualWidth-mywidth-7*StringLen(Vol), PriceY-10-height*n+n, LabelVName, Vol, VolumeColor);   
   }
   return true;
}
